%define libcxx_version %{expand:%(v="$LIBCXX_VERSION"; test "$v" = "" && v=0.13; echo $v)}

%{?compat: %define do_compat 1}
%{!?compat: %define do_compat 0}

%if %do_compat
Name: libcxxw%{expand:%(echo 0.08cxx%{libcxx_version} | tr -d '.')}
%else
Name: libcxxw
%endif
Summary: LibCXXW
Version: 0.8.0.%{libcxx_version}
Release: 1%{?extrarelease}
License: GPL
Group: System Environment/Libraries
URL: http://www.libcxx.org/w/
Source0: libcxxw-0.8.0.tar.bz2

%define _hardened_build 1

Requires: font(liberationsans)
Requires: font(liberationserif)
Requires: font(liberationmono)
Requires(post): /sbin/ldconfig
Requires(postun): /sbin/ldconfig

BuildRequires: libcxxbase-abi = %{libcxx_version}
BuildRequires: freetype-devel
BuildRequires: fontconfig-devel
BuildRequires: libxcb-devel
BuildRequires: xcb-proto
BuildRequires: xcb-util-wm-devel
BuildRequires: xcb-util-keysyms-devel
BuildRequires: xcb-util-image-devel
BuildRequires: xcb-util-renderutil-devel
BuildRequires: libX11-devel
BuildRequires: libjpeg-turbo-devel
BuildRequires: giflib-devel
BuildRequires: libpng-devel
BuildRequires: desktop-file-utils

%description
LibCXX widget toolkit.

%package cups
Group: System Environment/Libraries
Summary: LibCXXW print dialog
Requires: %{name} = 0:%{version}-%{release}

%description cups
This package installs the LibCXXW printing dialog library.

%package devel
Group: Development/Libraries
Summary: LibCXXW development libraries
Requires: %{name} = 0:%{version}-%{release}
Requires: libcxxbase-abi = %{libcxx_version}
Requires: libX11-devel

%description devel
This package installs files needed to develop applications that use LibCXXW.

%package devel-internals
Group: Development/Libraries
Summary: LibCXXW development libraries
Requires: %{name}-devel = 0:%{version}-%{release}
Requires: libxcb-devel
BuildRequires: xcb-util-renderutil-devel

%description devel-internals
This package installs additional internal header files for building
custom LibCXXW display elements.

%prep
%setup -q -n libcxxw-0.8.0
%configure

%build
%{__make} %{_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT
%{__make} install DESTDIR=$RPM_BUILD_ROOT
RPM_BUILD_ROOT="$RPM_BUILD_ROOT" desktop-file-install cxxwtheme.desktop
rm -f $RPM_BUILD_ROOT/%{_libdir}/*/*.la

echo '%defattr(-,root,root,-)' >public-headers

(cd $RPM_BUILD_ROOT; find .%{_includedir}/* -name impl -prune -o -type f -print) | sed 's/^.//' >>public-headers

(cd $RPM_BUILD_ROOT; find .%{_includedir}/* -name impl -prune -o -type d -print) | sed 's@^.@%dir @' >>public-headers

%if %do_compat
rm -f $RPM_BUILD_ROOT%{_datadir}/applications/*
rm -f $RPM_BUILD_ROOT%{_bindir}/*
rm -f $RPM_BUILD_ROOT%{_mandir}/*/*
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%dir %{_libdir}/libcxxw*
%{_libdir}/libcxxw*/libcxxw.so.*
%{_datadir}/libcxxw*

%if %do_compat

%else
%{_datadir}/applications/*
%{_bindir}/*
%{_mandir}/*/*
%endif

%files cups
%defattr(-,root,root,-)
%{_libdir}/libcxxw*/libcxxwcups.so.*

%files devel -f public-headers
%defattr(-,root,root,-)
%{_libdir}/libcxxw*/*.so
%{_libdir}/libcxxw*/*.a
%{_libdir}/pkgconfig/*
%{_datadir}/aclocal/*
%doc examples

%files devel-internals
%defattr(-,root,root,-)
%{_includedir}/*/x/w/impl
